<?php

namespace Api\Aramex\Tracking;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ShipmentTrackingRequest' => '\\Api\\Aramex\\Tracking\\StructType\\ShipmentTrackingRequest',
            'ClientInfo' => '\\Api\\Aramex\\Tracking\\StructType\\ClientInfo',
            'Transaction' => '\\Api\\Aramex\\Tracking\\StructType\\Transaction',
            'ShipmentTrackingResponse' => '\\Api\\Aramex\\Tracking\\StructType\\ShipmentTrackingResponse',
            'ArrayOfNotification' => '\\Api\\Aramex\\Tracking\\ArrayType\\ArrayOfNotification',
            'Notification' => '\\Api\\Aramex\\Tracking\\StructType\\Notification',
            'ArrayOfTrackingResult' => '\\Api\\Aramex\\Tracking\\ArrayType\\ArrayOfTrackingResult',
            'TrackingResult' => '\\Api\\Aramex\\Tracking\\StructType\\TrackingResult',
            'ArrayOfstring' => '\\Api\\Aramex\\Tracking\\ArrayType\\ArrayOfstring',
            'ArrayOfKeyValueOfstringArrayOfTrackingResultmFAkxlpY' => '\\Api\\Aramex\\Tracking\\ArrayType\\ArrayOfKeyValueOfstringArrayOfTrackingResultmFAkxlpY',
            'KeyValueOfstringArrayOfTrackingResultmFAkxlpY' => '\\Api\\Aramex\\Tracking\\StructType\\KeyValueOfstringArrayOfTrackingResultmFAkxlpY',
        );
    }
}
